Package ghidra.app.services

# Interface GoToService

All Known Implementing Classes:
  `GoToServiceImpl`

public interface GoToService
The GoToService provides a general service for plugins to generate GoTo events. The provider of this service will take care of interfacing with any history service that may be available.

This class will execute all `goTo` calls on the Java Swing thread. This will happen in a blocking manner if the client calls from any other thread. This has the potential to lead to deadlocks if the client is using custom synchronization. Care must be taken to not be holding any lock that will cause the Swing thread to block when using this class from any other thread. To work around this issue, clients can always call this service from within a `Swing.runLater(Runnable)` call, which will prevent any deadlock issues.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final char[]`
  `VALID_GOTO_CHARS`
  Characters that are allowed in words that the GoToService can use.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Navigatable`
  `getDefaultNavigatable()`
  Returns the default navigatable that is the destination for GoTo events.
  `GoToOverrideService`
  `getOverrideService()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  `boolean`
  `goTo(Navigatable navigatable, Address goToAddress)`
  Generates a GoTo event to the given address for the specific navigatable.
  `boolean`
  `goTo(Navigatable navigatable, Program program, Address address, Address refAddress)`
  Generates a GoTo event to the given address.
  `boolean`
  `goTo(Navigatable navigatable, ProgramLocation loc, Program program)`
  Generates a GoTo event to the given location in the given program.
  `boolean`
  `goTo(Address goToAddress)`
  Generates a GoTo event to the gotoAddress.
  `boolean`
  `goTo(Address fromAddress, Address address)`
  Generates a GoTo event to the given address.
  `boolean`
  `goTo(Address goToAddress, Program program)`
  Generates a GoTo event to the gotoAddress.
  `boolean`
  `goTo(ProgramLocation loc)`
  Generates a GoTo event and handles any history state that needs to be saved.
  `boolean`
  `goTo(ProgramLocation loc, Program program)`
  Generates a GoTo event and handles any history state that needs to be saved.
  `boolean`
  `goToExternalLocation(Navigatable navigatable, ExternalLocation externalLoc, boolean checkNavigationOption)`
  Navigate to either the external program location or address linkage location.
  `boolean`
  `goToExternalLocation(ExternalLocation externalLoc, boolean checkNavigationOption)`
  Navigate to either the external program location or address linkage location.
  `boolean`
  `goToQuery(Navigatable navigatable, Address fromAddr, QueryData queryData, GoToServiceListener listener, TaskMonitor monitor)`
  Generates a GoTo event for the given query.
  `boolean`
  `goToQuery(Address fromAddr, QueryData queryData, GoToServiceListener listener, TaskMonitor monitor)`
  Generates a GoTo event for the given query.
  `void`
  `setOverrideService(GoToOverrideService override)`
  Deprecated, for removal: This API element is subject to removal in a future version.

- ## Field Details

  - ### VALID_GOTO_CHARS

    static final char[] VALID_GOTO_CHARS
    Characters that are allowed in words that the GoToService can use. These typically represent library name delimiters.

- ## Method Details

  - ### goTo

    boolean goTo(ProgramLocation loc)
    Generates a GoTo event and handles any history state that needs to be saved. This method will attempt to find the program that contains the given ProgramLocation.
    Parameters:
      `loc` - location to go to
    Returns:
      true if the go to was successful
    See Also:
      - `goTo(ProgramLocation, Program)`

  - ### goTo

    boolean goTo(ProgramLocation loc, Program program)
    Generates a GoTo event and handles any history state that needs to be saved. This overloaded version of `goTo(Address)` uses the given program as the program within which to perform the GoTo. If the given program does not contain the given address, then the GoTo will not be performed and false will be returned. Passing `null` as the `program` parameter will cause this method to attempt to find a program that contains the given ProgramLocation.
    Parameters:
      `loc` - location to go to
      `program` - the program within which to perform the GoTo
    Returns:
      true if the go to was successful
    See Also:
      - `goTo(ProgramLocation)`

  - ### goTo

    boolean goTo(Navigatable navigatable, ProgramLocation loc, Program program)
    Generates a GoTo event to the given location in the given program.
    Parameters:
      `navigatable` - the destination navigatable
      `loc` - the location
      `program` - program
    Returns:
      true if the go to was successful

  - ### goTo

    boolean goTo(Navigatable navigatable, Program program, Address address, Address refAddress)
    Generates a GoTo event to the given address. The refAddress is used to determine if there is a specific symbol reference from that reference.
    Parameters:
      `navigatable` - the destination navigatable
      `program` - program
      `address` - the destination address
      `refAddress` - the from reference address
    Returns:
      true if the go to was successful

  - ### goTo

    boolean goTo(Address fromAddress, Address address)
    Generates a GoTo event to the given address. The fromAddress is used to determine if there is a specific symbol reference from the current address.
    Parameters:
      `fromAddress` - the current address
      `address` - the address to goto
    Returns:
      true if the go to was successful

  - ### goTo

    boolean goTo(Navigatable navigatable, Address goToAddress)
    Generates a GoTo event to the given address for the specific navigatable.
    Parameters:
      `navigatable` - the destination navigatable
      `goToAddress` - the address to goto
    Returns:
      true if the go to was successful

  - ### goTo

    boolean goTo(Address goToAddress)
    Generates a GoTo event to the gotoAddress.
    Parameters:
      `goToAddress` - the address to goto
    Returns:
      true if the go to was successful
    See Also:
      - `goTo(Address, Program)`

  - ### goTo

    boolean goTo(Address goToAddress, Program program)
    Generates a GoTo event to the gotoAddress. This overloaded version of `goTo(Address)` uses the given program as the program within which to perform the GoTo. If the given program does not contain the given address, then the GoTo will not be performed and false will be returned. Passing `null` as the `program` parameter will cause this method to attempt to find a program that contains the given ProgramLocation.
    Parameters:
      `goToAddress` - the address to goto
      `program` - the program within which to perform the GoTo
    Returns:
      true if the go to was successful
    See Also:
      - `goTo(Address)`

  - ### goToExternalLocation

    boolean goToExternalLocation(ExternalLocation externalLoc, boolean checkNavigationOption)
    Navigate to either the external program location or address linkage location. Specific behavior may vary based upon implementation.
    Parameters:
      `externalLoc` - external location
      `checkNavigationOption` - if true the service navigation option will be used to determine if navigation to the external program will be attempted, or if navigation to the external linkage location within the current program will be attempted. If false, the implementations default behavior will be performed.
    Returns:
      true if either navigation to the external program or to a linkage location was completed successfully.

  - ### goToExternalLocation

    boolean goToExternalLocation(Navigatable navigatable, ExternalLocation externalLoc, boolean checkNavigationOption)
    Navigate to either the external program location or address linkage location. Specific behavior may vary based upon implementation.
    Parameters:
      `navigatable` - Navigatable
      `externalLoc` - external location
      `checkNavigationOption` - if true the service navigation option will be used to determine if navigation to the external program will be attempted, or if navigation to the external linkage location within the current program will be attempted. If false, the implementations default behavior will be performed.
    Returns:
      true if either navigation to the external program or to a linkage location was completed successfully.

  - ### goToQuery

    boolean goToQuery(Address fromAddr, QueryData queryData, GoToServiceListener listener, TaskMonitor monitor)
    Generates a GoTo event for the given query.

    If the query results in more than one location, a list of locations will be displayed. If the query results in only one location, then a goto event will be fired(except for a wildcard query in which case a list will still be displayed.

    The listener will be notified after query and will indicate the query status.

    Parameters:
      `fromAddr` - The address used to determine the scope of the query
      `queryData` - the query input data
      `listener` - the listener that will be notified when the query completes
      `monitor` - the task monitor
    Returns:
      true if the queryInput is found or appears to be a wildcard search

  - ### goToQuery

    boolean goToQuery(Navigatable navigatable, Address fromAddr, QueryData queryData, GoToServiceListener listener, TaskMonitor monitor)
    Generates a GoTo event for the given query.

    If the query results in more than one location, a list of locations will be displayed. If the query results in only one location, then a goto event will be fired(except for a wildcard query in which case a list will still be displayed.

    The listener will be notified after query and will indicate the query status.

    Parameters:
      `navigatable` - the destination for the go to event
      `fromAddr` - The address used to determine the scope of the query
      `queryData` - the query input data
      `listener` - the listener that will be notified when the query completes
      `monitor` - the task monitor
    Returns:
      true if the queryInput is found or appears to be a wildcard search

  - ### getDefaultNavigatable

    Navigatable getDefaultNavigatable()
    Returns the default navigatable that is the destination for GoTo events. This navigatable will not be null.
    Returns:
      the navigatable

  - ### getOverrideService

    @Deprecated(forRemoval=true, since="10.2") GoToOverrideService getOverrideService()
    Deprecated, for removal: This API element is subject to removal in a future version.

  - ### setOverrideService

    @Deprecated(forRemoval=true, since="10.2") void setOverrideService(GoToOverrideService override)
    Deprecated, for removal: This API element is subject to removal in a future version.